import io from 'socket.io-client'
import PubSub from 'pubsub-js';

// const [isConnected, setIsConnected] = useState(socket.connected);
// const [fooEvents, setFooEvents] = useState([]);

class AccountAuth {
    constructor(url, id) {
        this.url = url;
        this.mapUUID = id
        // const URL = '121.42.8.157:19702'
        // this._socket = io(URL, {
        this._socket = io(url, {
            transports: ["websocket", "polling"],
            // path: '',
            autoConnect: true,
        });

        // console.log("AccountAuth connected", this._socket.connected, this._socket);
        this._socket.on('connect', this.onConnect);
        this._socket.on('connect_error', this.onError);
        this._socket.on('error', this.onError);
        this._socket.on('connect_timeout', this.onTimeout);
        this._socket.on('disconnect', this.onDisconnect);
        this.authed = false;
    }

    onConnect = () => {
        setTimeout(() => {
            var sql = `SELECT 
                        map_id,
                        map_data, 
                        map_name, 
                        create_time, 
                        map_uuid, 
                        update_time
                    FROM 
                        medba.dat_map 
                    WHERE 
                        map_uuid = '${this.mapUUID}'`;
            var msg = {
                cmd: "query", // server端要进行判断的
                data: {
                    name: "name", // 这个无所谓怎么写，有就行
                    sql: sql,
                },
            };
            this._socket.emit("REPT", msg, (res) => {
                // console.log(res.data);
                if (res && res.data && res.data.length > 0) {
                    // console.log(data[0].map_id);
                    PubSub.publish('body.draw.indoor', { source: "db", data: JSON.parse(res.data[0].map_data) });
                } else {
                    console.error(`DB has NO GeoJson Data Where mapid is ${this.mapUUID}`);
                }

            });
        }, 1000);
    }

    onError(e) {
        console.log("error", e);
    }

    onTimeout(e) {
        console.log("timeout", e);
    }

    onDisconnect(e) {
        console.log("disconnected", e);
    }

    authenticated() {
        return this.authed;
    }
}
export default AccountAuth;